#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <process.h>
#include <time.h>
#include <string.h>
#include <mbstring.h>
#include <wchar.h>
#include <windows.h>



void main(int argc, char *argv[])
{
   int rmin,tm,ch,dfn,sel,id,fn,stop,n;
   int m_s = 0, m_e = 0;
   char cmd[1024],mpath[256],dpath[512],rfn[512],ids[2],tims[32],opt[256],*dname,*ext;
   FILE *fp;
   
   fprintf(stderr,"cap_sts2hdus Ver.0.06\n");
   
   GetModuleFileName(NULL,mpath,256-1);
   _mbsrchr(mpath, '\\')[1] = 0;
   //printf("%s\n",mpath);
   
   tm = ch = dfn = /*sel =*/ id = stop = fn = 0;
   opt[0] = 0;
   
   for ( n = 1; n < argc; n++ ) {
      //printf("%s\n",argv[n]);
      if ( _mbschr(argv[n],'.') != NULL ) { dfn = n; continue; }
      if ( argv[n][0] == '@' ) { ch = n; continue; }
      if ( argv[n][0] == 'I' ) { id = n; continue; }
      if ( (argv[n][0] >= '0') && (argv[n][0] <= '9') ) { tm = n; continue; }
      if ( ((argv[n][0]|' ') == 's') && ((argv[n][1]|' ') == 't') && ((argv[n][2]|' ') == 'o') && ((argv[n][3]|' ') == 'p') ) { stop = n; continue; }
      if ( ((argv[n][0]|' ') == 'f') && ((argv[n][1]|' ') == 'n') ) { fn = n; continue; }
      //if ( ((argv[n][0]|' ') == 's') && ((argv[n][1]|' ') == 'e') && ((argv[n][2]|' ') == 'l') ) { sel = n; continue; }
   }
   //printf("%d %d %d %d %d %d\n",tm,ch,dfn,sel,id,stop);
   
   
   strcpy(dpath,mpath);
   strcat(dpath,"cap_sts2hdus.ini");
   if ( (fp = fopen(dpath,"r")) == NULL ) {
      printf("Cannot open '%s'\n",dpath);
      Sleep(6*1000);
      exit(1);
   }
   
   sscanf(argv[ch],"@%X",&ch);//`lϊCATV`l܂߂邽ch16iň.
   if ( id ) sscanf(argv[id],"I%d",&id);
   
   while ( !feof(fp) ) {
      char s[256];
      int d1,d2;
      
      fgets(s,256-1,fp);
      if ( *s == 'I' ) {
         sscanf(s,"I%d",&d1);
         if ( (id -= d1) <= 0 ) id = 0;
         continue;
      }
      if ( *s == 'M' ) {
         sscanf(s,"M%d,%d",&m_s,&m_e);
         if ( m_s <  0 ) m_s =  0;
         if ( m_s > 30 ) m_s = 30;
         if ( m_e <  0 ) m_e =  0;
         if ( m_e > 30 ) m_e = 30;
         continue;
      }
      if ( *s == '-' ) {
         strcpy(opt,s);
         continue;
      }
      if ( (ch > 0) && (*s == '@') ) {
         sscanf(s,"@%X,%X",&d1,&d2);//CATV`l܂߂邽ch16iň.
         if ( d1 == ch ) {
            ch = d2;
            break;
         }
         continue;
      }
      
   }
   fclose(fp);
   
   ids[1] = 0;
   ids[0] = !id ? 0 : ('0' + id);
   
   if ( stop ) {
      int ret;
      sprintf(cmd,"taskkill /F /IM cap_hdus%s.exe 1>nul 2>nul", ids);//
      ret = system(cmd);
      if ( !ret ) printf("cap_hdus%s.exe I܂B\n", ids);
      //Sleep(3*1000);
      exit(1);
   }
   
   if ( (ch == 0) || (tm == 0) || (dfn == 0) ) {
      printf("Not enough Parameter! (%X,%d,%d)\n",ch,tm,dfn);
      Sleep(6*1000);
      exit(1);
   }
   
#if 0
   if ( _mbsrchr(argv[dfn],'\\') == NULL ) {
      dpath[0] = '0';
      dpath[1] = 0;
      dname = argv[dfn];
   }
   else {
      strcpy(dpath,argv[dfn]);
      *(dname = _mbsrchr(dpath, '\\')) = 0;
      dname++;
   }
   
   {
      int sh,sm,eh,em;
      
      sscanf(argv[tm] + 0,"%02d:%02d-%02d:%02d", &sh,&sm, &eh,&em);
      sm += sh * 60;
      em += eh * 60;
      if ( em < sm ) em += 24 * 60;
      rmin = em - sm + 1;
   }
   
   //sel = (sel != 0);
   
   if ( strchr(argv[tm],':') != NULL ) {
      printf("Wait...\n");
      Sleep(30*1000);
   }
#endif
   
   
   if ( strchr(argv[tm],':') != NULL ) {
      int sh,sm,eh,em,st;
      char *p = strchr(argv[tm],'-');
      
      if ( p != NULL ) {
         p++;
      }
      else {
         p = argv[tm];
      }
      sscanf(p,"%d:%d",&eh,&em);
      
      sscanf(argv[tm],"%d:%d",&sh,&sm);
      if ( m_s > 0 ) {
         m_s = 60 - m_s;
         st = m_s - 20;
         if ( --sm < 0 ) {
            sm = 59;
            if ( --sh < 0 ) {
               sh = 23;
            }
         }
         sprintf(tims,"%02d:%02d:%02d-%02d:%02d:%02d", sh,sm,m_s, eh,em,m_e);
      }
      else {
         st = 60 - 20;
         sprintf(tims,"%02d:%02d:%02d-%02d:%02d:%02d", sh,sm,m_s, eh,em,m_e);
         if ( --sm < 0 ) {
            sm = 59;
            if ( --sh < 0 ) {
               sh = 23;
            }
         }
      }
      
      
      //printf("tims=%s\nstart=%d\n",tims,st);
      
      while ( TRUE ) {
         time_t timer = time(NULL);
         struct tm *date = localtime(&timer);
         
         if ( (date->tm_hour != sh) || (date->tm_min != sm) ) {
            printf("Please wait...    \x0d");
            Sleep(1000);
            continue;
         }
         
         if ( st <= date->tm_sec ) break;
         printf("Please wait...%d   \x0d", st - date->tm_sec);
         Sleep(100);
      }
      printf("                      \x0d");
      
   }
   else {
      strcpy(tims,argv[tm]);
   }
   
   
   {
      int ret;
      sprintf(cmd,"taskkill /F /IM cap_hdus%s.exe 1>nul 2>nul", ids);//
      ret = system(cmd);
      if ( !ret ) {
         printf("cap_hdus%s.exe I܂B\n", ids);
         Sleep(3*1000);
      }
   }
   
   
   ext = strrchr(argv[dfn],'.');
   *ext++ = 0;
   sprintf(rfn,"%s.%s",argv[dfn],ext);
   if ( !fn ) {
      for ( n = 1; TRUE; n++ ) {
         struct stat fst;
         if ( stat(rfn,&fst) ) break;
         sprintf(rfn,"%s(%d).%s",argv[dfn],n,ext);
      }
   }
   
   
   sprintf(cmd,"%scap_hdus%s.exe \"%s\" @%X %s %s", mpath, ids, rfn, ch, tims, opt);//CATV`l܂߂邽ch16iň.
   //sprintf(cmd,"%scap_hdus%s.exe \"%s\" @%d %s I%d %s", mpath, ids, rfn, ch, tims, id, opt);
   printf("%s\n",cmd);
   system(cmd);
   
   //sprintf(cmd,"start cmd /c %sDEC.bat \"%s\"", mpath, argv[dfn]);
   //system(cmd);
}
